;Calculator Operating System 86 v0.1
;Copyright Daniel "Krach" Foesch, 1998, All rights reserved

.org $8000

_curRow   = 0C00Fh
_curCol   = 0C010h
_penCol   = 0C37Ch
_penRow   = 0C37Dh
_textShadow  = 0C0F9h
_cmdShadow   = 0CFABh
_plotSScreen = 0C9FAh
Lalpha = 0BBh

_drawScrn = _plotSScreen
;_drawScrn = $FC00
        ld a, $00
        out (42), a
        ld a, $FF
        out (43), a
        out (43), a
        out (43), a

        ld a, $01
        out (42), a
        ld a, $00
        out (43), a
        out (43), a
        out (43), a

        ld a, $7C
        out ($00), a
        ld sp, $fc00
        ld iy, $c3e5
        ld a, $56
        out ($04), a
        ld a, $41
        out ($06), a
        ld a, %1011
        out ($3), a
;        im 0
;        ei

        ld de, COSStart
        ld hl, COSStart - $8000
        ld bc, COSEnd - $8000
        ldir
        jp COSStart

COSStart:

MainLp:
	ld bc, $0000
	ld hl, Menu_Img1
        call PutImage
	ld b, 64
	ld hl, Menu_Img2
	call PutImage

	ld de, $0110
	ld (_penCol), de
	ld hl, Menu_txt
;        call _vputs
	
        ld bc, $0036
	ld hl, SBar_Img1
	call PutImage
	ld b, 64
	ld hl, SBar_Img2
        call PutImage

	ld hl, Menu_lst
	call PutMenus

	ld bc, $0031
	ld hl, Win_Undr1
	call PutImage
	ld b, 64
	ld hl, Win_Undr2
	call PutImage

	ld a, $09
	ld b, $08
WinMkLp:
	ld c, a
	push bc
	ld b, $00
	ld hl, Win_Lft
	call PutImage
	ld b, 64
	ld hl, Win_Rgt
	call PutImage
	pop bc
	add a, 5
	djnz WinMkLp

	ld hl, Main_Fldr
	call PutIcons

	ld bc, (MS_Pos)
	ld hl, (MS_Pos+4)
;        call _HL2HL
        ld de, MS_Over
        call PutSprite_MSB

;WaitInp:
;	push bc
;	call _getkey
;	pop bc
;	cp K_NOKEY
;	jr z, WaitInp

	ld a, $FE
	out (1), a
	in a, (1)

	ld bc, (MS_Pos)
	push bc

	bit 1,a
	jr nz, SkpLf
	pop bc
	push af
	ld a, b
	dec a
	dec a
	and 127
	ld b, a
	pop af
	push bc
SkpLf:

	bit 2,a
	jr nz, SkpRt
	pop bc
	push af
	ld a, b
	inc a
	inc a
	and 127
	ld b, a
	pop af
	push bc
SkpRt:

	bit 3,a
	jr nz, SkpUp
	pop bc
	push af
	ld a, c
        dec a
	dec a
	and 63
	ld c, a
	pop af
	push bc
SkpUp:

	bit 0,a
	jr nz, SkpDw
	and $7F
	jr nz, MvDw
	ld a, $FD
	out (1), a
	in a, (1)
	bit 0, a
	jr nz, SkpDw
MvDw:
	pop bc
	push af
	ld a, c
	inc a
	inc a
	and 63
	ld c, a
	pop af
	push bc
SkpDw:

	ld hl, MS_Pos
        ld de, MS_Pos+2
	ldi
	ldi
	pop bc
        ld (MS_Pos), bc

	ld a, $BF
	out (1), a
	in a, (1)
	bit 5,a
	jr nz, SecUp
	ld hl, Main_Fldr
	call CheckClick
	jr SkpHld
SecUp:
	ld a, $DF
	out (1), a
	in a, (1)
	bit 7, a
	jr nz, AlphUp
	ld de, MS_Held
	ld (MS_Pos+4), de

	ld hl, Main_Fldr
	call CheckDrag
	ld hl, (MS_Pos+7)
	ld a, h
	or l
	cp 0
	jr z, SkpHld

	ld de, (MS_Pos)
	ld a, e
	sub 4
	ld (hl), a
	inc hl
	ld a, d
	sub 4
	ld (hl), a
	dec hl

;	ld c, (hl)
;	inc hl
;	ld b, (hl)
;	dec hl
;	call PixOn

	jr SkpHld

AlphUp:
	ld de, MS_Cursor
	ld (MS_Pos+4), de
SkpHld:

        call CopyGtoV           ;copy the graph mem to video mem
              
	ld a, $BF
	out (1), a
	in a, (1)
	bit 6,a
	jp nz, MainLp
	bit 7,a
	jp nz, MainLp

COS86_Exit:
        jp MainLp

;looks at the folder specified by hl, to check for a click on an icon
CheckClick:
	push af
	push bc
	push de
	push hl

	ld b, 8
	push hl
CC_Lp:
	push bc
	ld d, $0
	ld e, b
	add hl, de
	add hl, de
        call _HL2HL
        
	call CheckIconClick
	pop bc
	pop hl
	push hl
	djnz CC_Lp

	pop hl

	pop hl
	pop de
	pop bc
	pop af
	ret

;checks an icon (at hl) to see if MS_Pos is on the icon
CheckIconClick:
	push af
	push bc
	push de
	push hl

	ld bc, (MS_Pos)
	ld e, (hl)
	inc hl
	ld d, (hl)
	dec hl
	ld a, b
	sub d
	jr z, CIC_Chk2
	jr c, CIC_ChkDone
	cp 8
	jr z, CIC_Chk2
	jr nc, CIC_ChkDone

CIC_Chk2:
	ld a, c
	sub e
	jr z, CIC_Clck
	jr c, CIC_ChkDone
	cp 8
	jr z, CIC_Clck
	jr nc, CIC_ChkDone

CIC_Clck:
	inc hl
	inc hl
	inc hl
	ld a, (hl)
	dec hl
	dec hl
	dec hl
	cp 0
	jr z, CIC_ChkDone
	cp 1
	jr nz, CIC_NotMenu
	ld hl, NF_txt
	call ErrorMessage
	jr CIC_GetIconDone
CIC_NotMenu:
;	ld hl, NF_txt
;	call ErrorMessage
	call Run_Prg
CIC_GetIconDone:
	pop hl
	pop de
	pop bc
	pop af
	scf
	ret

CIC_ChkDone:
	pop hl
	pop de
	pop bc
	pop af
	or a
	ret

;looks at the folder specified by hl, to check for a drag on an icon
CheckDrag:
	push af
	push bc
	push de
	push hl

	ld de, 0
	ld (MS_Pos+7),de

	push hl
	ld b, 8
CD_Lp:
	push bc
	ld d, $0
	ld e, b
	add hl, de
	add hl, de
        call _HL2HL
	call CheckIconDrag
	pop bc
	pop hl
	push hl
	djnz CD_Lp

	pop hl

	pop hl
	pop de
	pop bc
	pop af
	ret

;checks an icon (at hl) to see if MS_Pos is on the icon
CheckIconDrag:
	push af
	push bc
	push de
	push hl

	ld bc, (MS_Pos)
	ld e, (hl)
	inc hl
	ld d, (hl)
	dec hl
	ld a, b
	sub d
	jr z, CID_Chk2
	jr c, CID_ChkDone
	cp 8
	jr z, CID_Chk2
	jr nc, CID_ChkDone

CID_Chk2:
	ld a, c
	sub e
	jr z, CID_Drag
	jr c, CID_ChkDone
	cp 8
	jr z, CID_Drag
	jr nc, CID_ChkDone

CID_Drag:
	inc hl
	inc hl
	inc hl
	ld a, (hl)
	dec hl
	dec hl
	dec hl
	cp 0
	jr z, CID_ChkDone
	ld (MS_Pos+7), hl

CID_ChkDone:
	pop hl
	pop de
	pop bc
	pop af
	ret

;puts icons in the icon list at hl
PutMenus:
	push af
	push bc
	push de
	push hl

	ld de, $0080
	ld (_penCol), de

	ld b, 4
	push hl
	ld h, d
	ld l, e
PMs_Lp:
	ld de, -$0018
	add hl, de
	ex de, hl
	ld (_penCol), de
	pop hl
	push hl
	push de
	push bc

	ld d, $0
	ld e, b
	add hl, de
	add hl, de
	add hl, de
	add hl, de
	ld de, -2
	add hl, de
	call _HL2HL
;        call _vputs

	pop bc
	pop hl
	djnz PMs_Lp

	pop hl

	pop hl
	pop de
	pop bc
	pop af
	ret

;puts icons in the icon list at hl
PutIcons:
	push af
	push bc
	push de
	push hl

	ld b, 8
	push hl
PIs_Lp:
	ld d, $0
	ld e, b
	add hl, de
	add hl, de
	call _HL2HL
	call PutIcon
	pop hl
	push hl
	djnz PIs_Lp

	pop hl

	pop hl
	pop de
	pop bc
	pop af
	ret

;puts an Icon,  hl = Icon_Info
PutIcon:
	push af
	push bc
	push de
	push hl

	push hl
	ld c, (hl)
	inc hl
	ld b, (hl)
	inc hl
	inc hl
	ld a, (hl)
	cp 0
	jr nz, PI_IsIcon
	pop hl
	jr PI_NoIcon
PI_IsIcon:
	cp 1
	jr nz, PI_NotMenu
	ld hl, Menu_Icon
	jr PI_GetIconDone
PI_NotMenu:
	cp 2
	jr nz, PI_NotAsm
	ld hl, Asm_Icon
	jr PI_GetIconDone
PI_NotAsm:
	ld hl, Bsc_Icon
PI_GetIconDone:
        ld de, MS_Over
        call PutSprite_MSB
	pop hl
	ld e, (hl)
	inc hl
	ld d, (hl)
	inc hl
	ld a, d
	sub (hl)
	ld (_penCol), a
	ld a, e
	add a, 8
	ld (_penRow), a

	inc hl
	inc hl
;        call _vputs

PI_NoIcon:
	pop hl
	pop de
	pop bc
	pop af
	ret

Run_Prg:
	push	de
	push	hl

	ld	de, 10
	add	hl, de

	ld hl, NF_txt
	call ErrorMessage
	pop	hl
	pop	de
	ret

ErrorMessage:
	push af
	push bc
	push de
	push hl

	ld hl, EM_Img
	ld bc, $2818
	call PutImage
	ld de, $1932
	ld (_penCol), de
        pop hl
	push hl
;        call _vputs
        call CopyGtoV           ;copy the graph mem to video mem

EM_Wait:			;wait for [More] button to be pressed
	ld a, $BF
	out (1), a
	in a,(1)
	bit 7, a
	jr nz, EM_Wait

	pop hl
	pop de
	pop bc
	pop af	
	ret

;waits until a key is pressed then waits until all keys are released
Wait4KeyPress:
	push af
W4K_NK:
	ld a, $00
	out (1), a
	in a, (1)
	cp $FF
	jr z, W4K_NK

	pop af

;waits for all keys to be released
Wait4KeyRelease:
	push af

W4K_KP:
	ld a, $00
	out (1), a
	in a, (1)
	cp $FF
	jr nz, W4K_KP

	pop af
	ret

_HL2HL:
  ld a, (hl)
  inc hl
  ld h, (hl)
  ld l, a
  ret

#include disp.h

BadRoot_txt:
.db "COSroot is Invalid!", 0

Menu_lst:
.dw 0
.dw Root_Name
.dw Root_Info
.dw Menu1_Name
.dw Menu1_Info
.dw Menu2_Name
.dw Menu2_Info
.dw Menu3_Name
.dw Menu3_Info

Root_Name:
.db "root",0,0
Root_Info:
.db $0C, 7, "COSroot", 0,0,0

Menu1_Name:
.db "aaaaa",0
Menu1_Info:
.db $0C, 0, "COS", 0,0,0

Menu2_Name:
.db "aaaaa",0
Menu2_Info:
.db $0C, 0, "COS", 0,0,0

Menu3_Name:
.db "aaaaa",0
Menu3_Info:
.db $0C, 0, "COS", 0,0,0

MS_Cursor:
 .db %10000000
 .db %11000000
 .db %10100000
 .db %10010000
 .db %10001000
 .db %11000100
 .db %00101000
 .db %00011000
 .db %10000000
 .db %11000000
 .db %11100000
 .db %11110000
 .db %11111000
 .db %11111100
 .db %00111000
 .db %00011000

MS_Held:
 .db %10000000
 .db %11000000
 .db %11100000
 .db %11110000
 .db %11111000
 .db %11111100
 .db %00111000
 .db %00011000
 .db %10000000
 .db %11000000
 .db %11100000
 .db %11110000
 .db %11111000
 .db %11111100
 .db %00111000
 .db %00011000

MS_Over:
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000

Menu_txt:
 .db " Calc O.S. '86 "
 .db " v0.1", Lalpha, " "
 .db 0

NF_txt:
 .db "Not Found!", 0

Menu_Icon:
 .db %00111000,
 .db %01000110,
 .db %11111001,
 .db %10000001,
 .db %10000001,
 .db %10000001,
 .db %10000001,
 .db %01111110,

 .db %00111000,
 .db %01111110,
 .db %11111111,
 .db %11111111,
 .db %11111111,
 .db %11111111,
 .db %11111111,
 .db %01111110,

Asm_Icon:
 .db %11111100,
 .db %10000110,
 .db %10000111,
 .db %10011001,
 .db %10101001,
 .db %10011001,
 .db %10000001,
 .db %11111111,

 .db %11111100,
 .db %11111110,
 .db %11111111,
 .db %11111111,
 .db %11111111,
 .db %11111111,
 .db %11111111,
 .db %11111111,

Bsc_Icon:
 .db %11111100,
 .db %10000110,
 .db %10100111,
 .db %10110001,
 .db %10101001,
 .db %10110001,
 .db %10000001,
 .db %11111111,

 .db %11111100,
 .db %11111110,
 .db %11111111,
 .db %11111111,
 .db %11111111,
 .db %11111111,
 .db %11111111,
 .db %11111111,

EM_Img:
 .db 6, 9
 .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111110,
 .db %10000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %10010101,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %10001010,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %10011011,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %10001010,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %10010101,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %10000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111110,


Menu_Img1:
 .db 8, 9
 .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,
 .db %10000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %10010101,%00011111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,
 .db %10001010,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %10011011,%00111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,
 .db %10001010,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %10010101,%00011111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,
 .db %10000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,

Menu_Img2:
 .db 8, 9
 .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111110,
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11100001,
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11110001,
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11100001,
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111110,

SBar_Img1:
 .db 8, 10
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,
 .db %10000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %10011111,%11100000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %10010000,%00100000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %10010000,%00100000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %10010000,%00100000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %10011111,%11100000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %10000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,

SBar_Img2:
 .db 8, 10
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111110,
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111110,

Win_Lft:
 .db 8, 5
 .db %10000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %10000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %10000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %10000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %10000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,

Win_Rgt:
 .db 8, 5
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,

Win_Undr1:
 .db 8, 5
 .db %10000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %10000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %10000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %10000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,
 .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,

Win_Undr2:
 .db 8, 5
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,
 .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111110,

MS_Pos:
 .db 32, 64, 32, 64
 .dw MS_Cursor
 .db 0
 .dw 0

Main_Fldr:
 .dw $0000
 .dw Info1
 .dw Info2
 .dw Info3
 .dw Info4
 .dw Info5
 .dw Info6
 .dw Info7
 .dw Info8

Info_Header:
 .db $0, $1
 .db 0,0,0,0,0,0

Info1:
 .db $0C, $0B, $3
 .db 1
 .db "fldr",0,0
 .db $12, 4, "COSfldr", 0,0,0,0

Info2:
 .db $1C, $0B, $5
 .db 2
 .db "dstar",0
 .db $12, 5, "dstar", 0,0,0

Info3:
 .db $0C, $1C, $5
 .db 3
 .db "SWDc",0,0
 .db $12, 6, "SWDice", 0,0

Info4:
 .db $0C, $2D, $0
 .db 3
 .db "null",0,0
 .db $12, 4, "null", 0,0,0,0

Info5:
 .db $0C, $3E, $0
 .db 3
 .db "null",0,0
 .db $12, 4, "null", 0,0,0,0

Info6:
 .db $1C, $1C, $0
 .db 3
 .db "null",0,0
 .db $12, 4, "null", 0,0,0,0

Info7:
 .db $1C, $2D, $0
 .db 3
 .db "null",0,0
 .db $12, 4, "null", 0,0,0,0

Info8:
 .db $1C, $3E, $0
 .db 3
 .db "null",0,0
 .db $12, 4, "null", 0,0,0,0

COSEnd:
.END
END
